<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Logical Time</title>
    <style>
        body,
        html,
        #plot {
            width: 100%;
            height: 100%;
            max-width: 100%;
            overflow: hidden;
        }

        body {
            margin: 0;
        }

        .text {
            font: 10px sans-serif;
        }

        .nodelabels:hover,
        .nodelabels:focus,
        .node-timeline:hover,
        .node-timeline:focus {
            cursor: pointer;
        }

        .packet:hover,
        .packet.focused {
            fill: #b80f0a;
            cursor: pointer;
        }
    </style>
</head>
<body>
<div id="plot"></div>

<script src="https://d3js.org/d3.v4.js"></script>

<script>
    const getAdditionalData = (data) => {
        const assignedY = {};
        let currentY = 100;

        /* Order nodes by their position */
        const keys = d3.keys(data.points);
        keys.sort((a, b) => {
            let [typeA, nA, lastA] = getNodeNumber(a);
            let [typeB, nB, lastB] = getNodeNumber(b);

            if (typeA !== typeB)
                return (typeA > typeB) ? -1 : 1;

            return (nA > nB) ? -1 : ((nB > nA) ? 1 : 0);
        });

        keys.forEach(key => {
            assignedY[key] = currentY;
            currentY += 50;
        });

        let clocks = [];
        d3.keys(assignedY).forEach(key => {
            clocks = clocks.concat(d3.keys(data.points[key]).map(x => parseInt(x)));
        });

        const minTime = d3.min(clocks);
        const maxTime = d3.max(clocks);

        return [assignedY, minTime, maxTime];
    };
    const getNodeNumber = (name) => {
        const nodeName = name.split("_");
        const nodeType = nodeName.shift();

        const nodeNumber = parseInt(nodeName.join(""));
        const lastNumber = parseInt(nodeName[2]);

        return [nodeType, nodeNumber, lastNumber];
    };
</script>
<script>
    const tofColors = ["#78b5d8", "#76b4d8", "#75b3d7", "#73b2d7", "#72b1d7", "#70b0d6", "#6fafd6", "#6daed5", "#6caed5", "#6badd5", "#69acd4", "#68abd4", "#66aad3", "#65a9d3", "#63a8d2", "#62a7d2", "#61a7d1", "#5fa6d1", "#5ea5d0", "#5da4d0", "#5ba3d0", "#5aa2cf", "#59a1cf", "#57a0ce", "#569fce", "#559ecd", "#549ecd", "#529dcc", "#519ccc", "#509bcb", "#4f9acb", "#4d99ca", "#4c98ca", "#4b97c9", "#4a96c9", "#4895c8", "#4794c8", "#4693c7", "#4592c7", "#4492c6", "#4391c6", "#4190c5", "#408fc4", "#3f8ec4", "#3e8dc3", "#3d8cc3", "#3c8bc2", "#3b8ac2", "#3a89c1", "#3988c1", "#3787c0", "#3686c0", "#3585bf", "#3484bf", "#3383be", "#3282bd", "#3181bd", "#3080bc", "#2f7fbc", "#2e7ebb", "#2d7dbb", "#2c7cba", "#2b7bb9", "#2a7ab9", "#2979b8", "#2878b8", "#2777b7", "#2676b6", "#2574b6", "#2473b5", "#2372b4", "#2371b4", "#2270b3", "#216fb3", "#206eb2", "#1f6db1", "#1e6cb0", "#1d6bb0", "#1c6aaf", "#1c69ae", "#1b68ae", "#1a67ad", "#1966ac", "#1865ab", "#1864aa", "#1763aa", "#1662a9", "#1561a8", "#1560a7", "#145fa6", "#135ea5", "#135da4", "#125ca4", "#115ba3", "#115aa2", "#1059a1", "#1058a0", "#0f579f", "#0e569e", "#0e559d", "#0e549c", "#0d539a", "#0d5299", "#0c5198", "#0c5097", "#0b4f96", "#0b4e95", "#0b4d93", "#0b4c92", "#0a4b91", "#0a4a90", "#0a498e", "#0a488d", "#09478c", "#09468a", "#094589", "#094487", "#094386", "#094285", "#094183", "#084082", "#083e80", "#083d7f", "#083c7d", "#083b7c", "#083a7a", "#083979", "#083877", "#083776", "#083674", "#083573", "#083471", "#083370", "#08326e", "#08316d", "#08306b"].reverse();
    const spineColors = ["#fc9548", "#fc9346", "#fc9245", "#fc9143", "#fc9042", "#fb8f40", "#fb8e3f", "#fb8d3e", "#fb8c3c", "#fb8b3b", "#fa8a3a", "#fa8938", "#fa8837", "#fa8736", "#fa8534", "#f98433", "#f98332", "#f98230", "#f8812f", "#f8802e", "#f87f2c", "#f77e2b", "#f77d2a", "#f77b29", "#f67a27", "#f67926", "#f57825", "#f57724", "#f57623", "#f47522", "#f47420", "#f3731f", "#f3721e", "#f2701d", "#f26f1c", "#f16e1b", "#f16d1a", "#f06c19", "#f06b18", "#ef6a17", "#ef6916", "#ee6815", "#ed6714", "#ed6614", "#ec6513", "#ec6312", "#eb6211", "#ea6110", "#ea6010", "#e95f0f", "#e85e0e", "#e85d0e", "#e75c0d", "#e65b0c", "#e55a0c", "#e4590b", "#e4580b", "#e3570a", "#e25609", "#e15509", "#e05408", "#df5308", "#de5208", "#dd5207", "#dc5107", "#db5006", "#da4f06", "#d94e06", "#d84d05", "#d74c05", "#d64c05", "#d54b04", "#d44a04", "#d24904", "#d14804", "#d04804", "#cf4703", "#cd4603", "#cc4503", "#cb4503", "#c94403", "#c84303", "#c74303", "#c54203", "#c44103", "#c24102", "#c14002", "#bf3f02", "#be3f02", "#bd3e02", "#bb3e02", "#ba3d02", "#b83d02", "#b73c02", "#b53b02", "#b43b02", "#b23a03", "#b13a03", "#af3903", "#ae3903", "#ac3803", "#ab3803", "#aa3703", "#a83703", "#a73603", "#a53603", "#a43503", "#a33503", "#a13403", "#a03403", "#9f3303", "#9d3303", "#9c3203", "#9b3203", "#993103", "#983103", "#973003", "#953003", "#942f03", "#932f03", "#922e04", "#902e04", "#8f2d04", "#8e2d04", "#8d2c04", "#8b2c04", "#8a2b04", "#892b04", "#882a04", "#862a04", "#852904", "#842904", "#832804", "#812804", "#802704", "#7f2704"].reverse();
    const leafColors = ["#7ec980", "#7dc87f", "#7bc77e", "#7ac77c", "#78c67b", "#77c57a", "#75c479", "#74c478", "#72c378", "#71c277", "#6fc276", "#6ec175", "#6cc074", "#6bbf73", "#69bf72", "#68be71", "#66bd70", "#65bc6f", "#63bc6e", "#62bb6e", "#60ba6d", "#5eb96c", "#5db86b", "#5bb86a", "#5ab769", "#58b668", "#57b568", "#56b467", "#54b466", "#53b365", "#51b264", "#50b164", "#4eb063", "#4daf62", "#4caf61", "#4aae61", "#49ad60", "#48ac5f", "#46ab5e", "#45aa5d", "#44a95d", "#42a85c", "#41a75b", "#40a75a", "#3fa65a", "#3ea559", "#3ca458", "#3ba357", "#3aa257", "#39a156", "#38a055", "#379f54", "#369e54", "#359d53", "#349c52", "#339b51", "#329a50", "#319950", "#30984f", "#2f974e", "#2e964d", "#2d954d", "#2b944c", "#2a934b", "#29924a", "#28914a", "#279049", "#268f48", "#258f47", "#248e47", "#238d46", "#228c45", "#218b44", "#208a43", "#1f8943", "#1e8842", "#1d8741", "#1c8640", "#1b8540", "#1a843f", "#19833e", "#18823d", "#17813d", "#16803c", "#157f3b", "#147e3a", "#137d3a", "#127c39", "#117b38", "#107a37", "#107937", "#0f7836", "#0e7735", "#0d7634", "#0c7534", "#0b7433", "#0b7332", "#0a7232", "#097131", "#087030", "#086f2f", "#076e2f", "#066c2e", "#066b2d", "#056a2d", "#05692c", "#04682b", "#04672b", "#04662a", "#03642a", "#036329", "#026228", "#026128", "#026027", "#025e27", "#015d26", "#015c25", "#015b25", "#015a24", "#015824", "#015723", "#005623", "#005522", "#005321", "#005221", "#005120", "#005020", "#004e1f", "#004d1f", "#004c1e", "#004a1e", "#00491d", "#00481d", "#00471c", "#00451c", "#00441b"].reverse();

    let tofColorScale = null, spineColorScale = null, leafColorScale = null;

    const createColorScales = (nodes) => {
        let tofValueMin = Infinity, tofValueMax = -Infinity;
        let spineValueMin = Infinity, spineValueMax = -Infinity;
        let leafValueMin = Infinity, leafValueMax = -Infinity;

        nodes.forEach((item) => {
            const [nodeType, nodeNumber, lastNumber] = getNodeNumber(item);

            if (nodeType === "tof") {
                tofValueMin = Math.min(tofValueMin, nodeNumber);
                tofValueMax = Math.max(tofValueMax, nodeNumber * lastNumber);
            }
            if (nodeType === "spine") {
                spineValueMin = Math.min(spineValueMin, nodeNumber);
                spineValueMax = Math.max(spineValueMax, nodeNumber * lastNumber);
            }
            if (nodeType === "leaf") {
                leafValueMin = Math.min(leafValueMin, nodeNumber);
                leafValueMax = Math.max(leafValueMax, nodeNumber * lastNumber);
            }
        });

        tofColorScale = d3.scaleLinear()
            .domain([tofValueMin, tofValueMax])
            .range([0, tofColors.length - 1]);
        spineColorScale = d3.scaleLinear()
            .domain([spineValueMin, spineValueMax])
            .range([0, tofColors.length - 1]);
        leafColorScale = d3.scaleLinear()
            .domain([leafValueMin, leafValueMax])
            .range([0, tofColors.length - 1]);
    };
    const getNodeColor = (name) => {
        const [nodeType, nodeNumber, lastNumber] = getNodeNumber(name);

        if (nodeType === "tof")
            return tofColors[Math.floor(tofColorScale(nodeNumber * lastNumber))];

        if (nodeType === "spine")
            return spineColors[Math.floor(spineColorScale(nodeNumber * lastNumber))];

        if (nodeType === "leaf")
            return leafColors[Math.floor(leafColorScale(nodeNumber * lastNumber))];
    };
</script>
<script>
    const data = "%PLOT%";

    let [assignedY, minClock, maxClock] = getAdditionalData(data);

    const minX = 0;
    const intervalWidth = (maxClock * 1000) / 25;
    const maxX = intervalWidth;

    const minY = d3.min(d3.values(assignedY));
    const maxY = d3.max(d3.values(assignedY));

    createColorScales(d3.keys(assignedY));

    /* Main plot init */
    const plot = d3.select('#plot');

    const svg = plot.append('svg')
        .attr('width', "100%")
        .attr('height', "100%")
        .call(d3.zoom()
            .on("zoom", () => {
                g.attr("transform", d3.event.transform);
            })
        );

    const g = svg.append('g')
        .attr('width', "100%")
        .attr('height', "100%");

    svg.attr("viewBox", [-100, minY, maxX + 200, maxY - minY + 10]);

    /* Logical Time plot */
    const nodeLabels = g.selectAll(".nodelabels")
        .data(d3.keys(assignedY))
        .enter()
        .append("text")
        .text(d => d)
        .attr("class", "text nodelabels")
        .attr("x", -50)
        .attr("y", d => assignedY[d])
        .attr("dy", 2.5)
        .attr("fill", d => getNodeColor(d))
        .style("text-anchor", "middle");

    const radius = 5;
    const lineWidth = 2;
    const margin = 15;

    let timelineLines = g.selectAll(".node-timeline")
        .data(d3.keys(assignedY))
        .enter()
        .append("line")
        .attr("class", d => "node-timeline " + d + "-timeline")
        .attr("x1", minX)
        .attr("x2", maxX)
        .attr("y1", d => assignedY[d])
        .attr("y2", d => assignedY[d])
        .style("stroke", d => getNodeColor(d))
        .style("stroke-width", lineWidth);

    const step = (maxX - (minX + (margin * 2))) / (maxClock - minClock);
    d3.keys(assignedY).forEach(key => {
        d3.keys(data.points[key]).forEach(idx => {
            const x = data.points[key][idx];

            g.selectAll("." + key + "-packet-" + idx)
                .data([x])
                .enter()
                .append("circle")
                .attr("class", "packet " + key + "-packet " + key + "-packet-" + idx)
                .attr("r", radius)
                .attr("cy", assignedY[key])
                .attr("cx", margin + minX + (step * (idx - minClock)))
                .attr("stroke", "black")
                .attr("stroke-width", 0.5)
                .attr("fill", getNodeColor(key));
        });
    });

    const filteredEdges = data.edges.filter(x => x[0][1] != null && x[1][1] != null);
    const noDestEdges = data.edges.filter(x => !filteredEdges.includes(x));

    const packetEgdes = g.selectAll(".packet-edges")
        .data(filteredEdges)
        .enter()
        .append("line")
        .attr("class", d => "packet-edges packet-edge" + d + "-packet-edge")
        .attr("x1", d => margin + minX + (step * (d[0][1] - minClock)))
        .attr("x2", d => margin + minX + (step * (d[1][1] - minClock)))
        .attr("y1", d => assignedY[d[0][0]])
        .attr("y2", d => assignedY[d[1][0]])
        .style("stroke", d => getNodeColor(d[0][0]))
        .style("stroke-width", 1);

    packetEgdes.append('path')
        .attr("d", d => {
            let x1, x2, y1, y2;

            if (assignedY[d[0][0]] < assignedY[d[1][0]]) {
                x1 = margin + minX + (step * (d[0][1] - minClock));
                x2 = margin + minX + (step * (d[1][1] - minClock));
                y1 = assignedY[d[0][0]];
                y2 = assignedY[d[1][0]];
            } else {
                x1 = margin + minX + (step * (d[1][1] - minClock));
                x2 = margin + minX + (step * (d[0][1] - minClock));
                y1 = assignedY[d[1][0]];
                y2 = assignedY[d[0][0]];
            }

            return 'M ' + x1 + ' ' + y1 + ' L ' + x2 + ' ' + y2;
        })
        .attr("fill-opacity", 0)
        .attr("stroke-opacity", 0)
        .attr("id", d => d + "-packet-edge-path")
        .style("pointer-events", "none");

    const packetEgdesArrows = g.selectAll(".packet-edge-arrows")
        .data(filteredEdges)
        .enter()
        .append('text')
        .attr("class", d => "packet-edge-arrows " + d + "-packet-edge-arrow")
        .attr("dy", 13.5)
        .attr("fill", d => getNodeColor(d[0][0]))
        .attr("font-size", "20px")
        .style("pointer-events", "none")
        .style("text-anchor", "middle");

    packetEgdesArrows.append('textPath')
        .text(d => (assignedY[d[0][0]] < assignedY[d[1][0]]) ? "\u02C3" : "\u02C2")
        .attr("startOffset", d => (assignedY[d[0][0]] < assignedY[d[1][0]]) ? "99%" : 0)
        .attr('xlink:href', d => "#" + d + "-packet-edge-path")
        .style("pointer-events", "none");

    const noDestEdgesMarkers = g.selectAll(".no-dest-edges")
        .data(noDestEdges)
        .enter()
        .append("text")
        .html("&times;")
        .attr("class", "no-dest-edges")
        .attr("x", d => margin + minX + (step * (d[0][1] - minClock)))
        .attr("y", d => assignedY[d[0][0]])
        .attr("dy", 5)
        .style("pointer-events", "none")
        .style("text-anchor", "middle");

    const transitionDuration = 250;

    /* Node Timeline Highlight */
    const focusNodeTimeline = nodeName => {
        timelineLines.transition()
            .duration(transitionDuration)
            .style('opacity', (d) => d === nodeName ? 1 : 0.1);

        const nodeEdges = data.edges.filter(x => x[0][0] === nodeName || x[1][0] === nodeName);

        g.selectAll('.packet')
            .transition()
            .duration(transitionDuration)
            .style('opacity', (x, i, nodes) => {
                const nodeClass = nodes[i].className.baseVal;

                for (let i = 0; i < nodeEdges.length; ++i) {
                    const x = nodeEdges[i];

                    const startNode = x[0][0];
                    const startIdx = x[0][1];
                    const endNode = x[1][0];
                    const endIdx = x[1][1];

                    const nodeStartClass = startNode + "-packet-" + startIdx;
                    const nodeEndClass = endNode + "-packet-" + endIdx;

                    if (nodeClass.includes(nodeStartClass) || nodeClass.includes(nodeEndClass))
                        return 1;
                }

                return 0.1;
            });

        packetEgdes
            .transition()
            .duration(transitionDuration)
            .style('opacity', d => nodeEdges.includes(d) ? 1 : 0.1);

        packetEgdesArrows
            .transition()
            .duration(transitionDuration)
            .style('opacity', d => nodeEdges.includes(d) ? 1 : 0.1);

        noDestEdgesMarkers
            .transition()
            .duration(transitionDuration)
            .style('opacity', d => d[0][0] === nodeName ? 1 : 0.1);
    };

    timelineLines.on('click', x => {
        focusNodeTimeline(x);
    });
    nodeLabels.on('click', x => {
        focusNodeTimeline(x);
    });

    const clearNodeFocus = () => {
        timelineLines.transition().duration(transitionDuration).style('opacity', 1);
        g.selectAll('.packet').transition().duration(transitionDuration).style('opacity', 1);
        packetEgdes.transition().duration(transitionDuration).style('opacity', 1);
        packetEgdesArrows.transition().duration(transitionDuration).style('opacity', 1);
        noDestEdgesMarkers.transition().duration(transitionDuration).style('opacity', 1);
    };

    /* Packets Highlight */
    const clearFocus = () => {
        if (focused === null)
            return;

        focused = null;

        d3.selectAll('.packet.focused').classed('focused', false);
        hideOverlay();
    };

    let focused = null;
    g.selectAll(".packet")
        .on('click', x => {
            /* Clear previous focus */
            if (focused !== null)
                clearFocus();

            d3.select(d3.event.target)
                .classed('focused', true);

            focused = x;
            showOverlay(x);
        });
    d3.select("body").on("keydown", () => {
        if (d3.event.keyCode === 67) {
            clearNodeFocus();
            clearFocus();
        }
    });
</script>

%OVERLAY_SCRIPT%
</body>
</html>